use strict; use warnings;
my @employees = (
  { 'Lastname' => 'Smith', 'Firstname' => 'John', 'Salary' => 25000 },
  { 'Lastname' => 'Smith', 'Firstname' => 'Linda', 'Salary' => 22500 },
  { 'Lastname' => 'Jones', 'Firstname' => 'Lisa', 'Salary' => 26400 }
);
print "\nExample: Array of hashes.";
# Adding a new employee (using a reference to a hash)
my %new_employee = ( 'Lastname' => 'Burns', 'Firstname' => 'Mark', 'Salary' => 23800 );
$employees[3] = \%new_employee;
# Changing the salary of an employee (direct access to the hash element using a "double index")
$employees[1]{Salary} = 23000;
# Extracting all data concerning a given employee (using a reference to the hash)
my $ref_employee3_data = $employees[3]; my %employee3_data = %$ref_employee3_data;
print "\n\nEmployee [3] is: $employee3_data{Lastname} $employee3_data{Firstname} (salary = $employee3_data{Salary})";
# Extracting data concerning a given employee (direct access to the hash elements using "double indices")
print "\nEmployee [1] is: $employees[1]{Lastname} $employees[1]{Firstname} (salary = $employees[1]{Salary})";
# Displaying all employees (dereferencing the reference to the hashes)
print "\n\nList of all employees:\n";
for my $employee (@employees) {
  my %employee_data = %$employee;
  print "$employee_data{Lastname} $employee_data{Firstname} (salary = $employee_data{Salary})\n";
}
