# Displaying all grades of all students, ordered by subject and student name
use strict; use warnings;
my %grades = (
  'Smith Ben'   => {
    'Mathematics' => 92,
    'Literature'  => 73,
    'Art'         => 64
  },
  'Jones Kim'   => {
    'Mathematics' => 75,
    'Science'     => 78,
    'Literature'  => 93,
    'Art'         => 97
  },
  'Smith Jenny' => {
    'Art'         => 80,
    'Literature'  => 85,
    'Mathematics' => 90,
    'Science'     => 91
  },
  'Burns Tom'   => {
    'Literature'  => 78,
    'Mathematics' => 84,
    'Science'     => 86
  }
);
print "\nGrades of all students (ordered by subject and student name):\n";
my @students = sort keys %grades; my @subjects = ();              # make sorted list of students
foreach my $student (@students) {                                 # make sorted list of subjects (keep the one with the maximum number of elements)
  my $ref_subjects_student = $grades{$student};
  if (scalar keys %$ref_subjects_student > scalar @subjects) {
    @subjects = sort keys %$ref_subjects_student;
  }
}
foreach my $subject (@subjects) {                                 # for each subject, iterate the students list and display the student's name and grade
  print "\n  $subject:\n";
  foreach my $student (@students) {
  if (defined($grades{$student}{$subject})) {                     # exclude the students who have no grade for this subject
      print "    $student: $grades{$student}{$subject}\n";
    }
  }
}
