# Displaying all grades of all students, ordered by subject and grade
use strict; use warnings;
my %grades = (
  'Smith Ben'   => {
    'Mathematics' => 92,
    'Literature'  => 73,
    'Art'         => 64
  },
  'Jones Kim'   => {
    'Mathematics' => 75,
    'Science'     => 78,
    'Literature'  => 93,
    'Art'         => 97
  },
  'Smith Jenny' => {
    'Art'         => 80,
    'Literature'  => 85,
    'Mathematics' => 90,
    'Science'     => 91
  },
  'Burns Tom'   => {
    'Literature'  => 78,
    'Mathematics' => 84,
    'Science'     => 86
  }
);
print "\nGrades of all students (ordered by subject and grade):\n";
# Make list of all students (we'll create sorted lists for each subject later)
my @students = keys %grades; my @subjects = ();
# Make sorted list of all subjects
foreach my $student (@students) {
  my $ref_subjects_student = $grades{$student};
  if (scalar keys %$ref_subjects_student > scalar @subjects) {   # keep the list with the maximum number of sunjects
   @subjects = sort keys %$ref_subjects_student;
  }
}
# Perform the outer loop for each subject in the sorted subjects list
foreach my $subject (@subjects) {
  print "\n  $subject:\n";
  # Replace undef variables with -1 to avoid undefined numeric values during sort
  foreach my $student (@students) {
    if (!defined($grades{$student}{$subject})) {
      $grades{$student}{$subject} = -1;
    }
  }
  # Using the initial students list, create another students list for the actual subject and sorted by grade
  my @students_subject = sort { $grades{$b}{$subject} <=> $grades{$a}{$subject} } @students;
  # Perform the inner loop (display) for each student in the students list sorted by grade
  foreach my $student (@students_subject) {
    unless ($grades{$student}{$subject} == -1) {                 # exclude the students who have no grade for this subject
      print "    $student: $grades{$student}{$subject}\n";
    }
  }
}
