use strict; use warnings;
print "\nExample: Returning a hash from a subroutine that fills it.";
# Call the sub to fill the hash (return value is a hash-reference)
my $ref_amino_acids = fill_hash(); my %amino_acids = %$ref_amino_acids;
# Display the hash
print "\n\nAmino acids list by 3-letter code:\n";
foreach my $code3 (sort keys %amino_acids) {
  print "  $code3   $amino_acids{$code3}\n";
}
exit;

# Subroutine to fill the hash
sub fill_hash {
  my %aa = (
    'Ala' => 'alanine',
    'Arg' => 'arginine',
    'Asn' => 'asparagine',
    'Gln' => 'glutamine',
    'Glu' => 'glutamic acid',
    'Cys' => 'cysteine'
  );
  return \%aa;                 # return the hash as reference
}
